from dataclasses import dataclass

from ..result import Result
from ..transformer import Transformer
from .map import MapTransform


ConcatInput = Transformer[str] | tuple["ConcatInput", "ConcatInput"]


@dataclass
class ConcatTransform(Transformer[str]):
    from_: Transformer[tuple[str, str]]
    join: str

    def __init__(self, from_: Transformer[tuple[str, str]], join: str) -> None:
        self.from_ = from_
        self.join = join
        self.actual = MapTransform(self.from_, lambda l: join.join(l))

    def parse(self, stream: str, at_index: int) -> Result[str]:
        return self.actual.parse(stream, at_index)


from okipy.lib import test

# TOTEST
