from typing import Callable, Collection, Generator, Generic, Iterable, TypeVar, Union

from okipy.lib import test


T = TypeVar("T")
class TypeInfo(Generic[T]):
    pass


T = TypeVar("T")
K = TypeVar("K", int, float)
def best_by_key(collection: Iterable[T], extract: Callable[[T], K], max_: bool = True):
    best: Union[tuple[T,K], None] = None
    for item in collection:
        key = extract(item)
        if best is None:
            best = (item, key)
            continue
        should_replace = (max_ and key > best[1]) or (not max_ and key < best[1])
        if should_replace:
            best = (item, key)
    return best[0] if best is not None else None


def split_lines_into_bounded(text: str) -> Generator[tuple[tuple[int, int], str], None, None]:
    rest = text
    acc = 0
    while True:
        parts = rest.split("\n", 1)
        start = acc
        acc += len(parts[0])
        end = acc
        yield ((start, end), parts[0])
        acc += 1
        if len(parts) == 1:
            break
        rest = parts[1]


@test()
def test_split_lines_bounded(ctx):
    input = "\nhello\n\nworld\n"
    splitted = [*split_lines_into_bounded(input)]
    assert splitted == [
        ((0, 0), ''),
        ((1, 6), 'hello'),
        ((7, 7), ''),
        ((8, 13), 'world'),
        ((14, 14), '')
    ]


T = TypeVar("T")
def last(collection: Collection[T]):
    result = None
    for item in collection:
        result = item
    return result
